from getopt import GetoptError, getopt
from json import dumps, load
from sys import argv, exit
from openpyxl import Workbook
from openpyxl.styles import Alignment
from itertools import cycle
#from pdb import set_trace as bp
#import pprint
from re import match

# def pritiPrint(x):
# 	print(dumps(x, indent=4, sort_keys=True))

def colnum_string(n):
    string = ""
    while n > 0:
        n, remainder = divmod(n - 1, 26)
        string = chr(65 + remainder) + string
    return string

def digito_verificador(rut):
    reversed_digits = map(int, reversed(str(rut)))
    factors = cycle(range(2, 8))
    s = sum(d * f for d, f in zip(reversed_digits, factors))
    s =  (-s) % 11
    if s == 10:
    	return 'k'
    else:
    	return str(s)

def mapped(e):
    if type(e) != str:
        return e
    if match("^-?\d+?\.\d+?$", e):
        return float(e)
    if match("^-?\d+?$", e):
        return int(e)
    return 0

def calcularPtje(tipo,ptjes_resp_correcta,respuesta_usuario):
	if tipo == 'alternativa':
		return ptjes_resp_correcta[int(respuesta_usuario)]
	elif tipo == 'tabla':
		n1 = mapped(ptjes_resp_correcta[int(respuesta_usuario[0])])
		n2 = mapped(ptjes_resp_correcta[int(respuesta_usuario[1])+2])
		n3 = mapped(ptjes_resp_correcta[int(respuesta_usuario[2])+4])
		return str(n1+n2+n3)
	else:
		return '-12'


# Leyendo archivos
if len(argv) == 1:
	print('La forma correcta es: notas -f <archivo>')
	exit(2)
elif len(argv) > 1:
	try:
		opts, args = getopt(argv[1:],"f:")
		nombre_archivo = argv[2]

	except GetoptError:
		print('La forma correcta es: notas -f <archivo>')
		exit(2)
	
	if len(argv) > 3:
		print('La forma correcta es: notas -f <archivo>')
		exit(2)


# Leyendo datos
with open(nombre_archivo, 'r') as f:
    distros_dict = load(f)
#pp = pprint.PrettyPrinter(indent=4)

pregs_control = []

ppl = []
name = distros_dict['nombre'] +'_id_'+ distros_dict['id']
resps = distros_dict['respuestas']

categorias = [k for k in distros_dict['categorias'].values()]
ptjes = [k for k in distros_dict['preguntas'].values()]
ptjes = [j for i in ptjes for j in i]
for p in ptjes:
	if p['tipo'] == 'instruccion':
		ptjes.pop(ptjes.index(p))

for r in resps:
	#pritiPrint(distros_dict['respuestas'][r])
	resps_person = distros_dict['respuestas'][r]['respuestas']
	person_s = [-1.0] * 15
	person_c = ['nodata'] * 15
	person_r = [''] * 15
	person = r
	pages = []
	salir = 0
	for p in resps_person:
		pages.append(resps_person[p])

	pages = [j for sub in pages for j in sub]
	
	for p in pages:
		if p['tipo'] == 'instruccion':
			pages.pop(pages.index(p))
	#bp()
	
	for i in range(len(pages)):
		try:
			catt = ''
			if 'categoria' in pages[i]:
				catt = pages[i]['categoria']
			else:
				catt = categorias[i]
			if 'puntaje' in pages[i]:
				ptje = pages[i]['puntaje']
				person_s[i] = int(ptje) / int(pages[i]['puntaje_max'])
			else:
				ptje = calcularPtje(pages[i]['tipo'],ptjes[i]['puntaje'],pages[i]['respuesta'])
				person_s[i] = mapped(ptje) / int(ptjes[i]['puntaje_total'])
				if person_s[i] == -1:
					person_s[i] = 'sin datos en u-cursos. Na que hacer'
			
			person_c[i] = catt + '_' + pages[i]['tipo']
			if isinstance(pages[i]['respuesta'],list):
				person_r[i] = ', '.join(pages[i]['respuesta'])
			else:
				person_r[i] =  pages[i]['respuesta'].replace('<p>','').replace('</p>','').replace('&nbsp;','')
		except Exception as inst:
			#print("Unexpected error:", sys.exc_info()[0])
			#raise
			#bp()
			salir = 1
	if salir:
		continue
	#caso omitadas
	if 'nodata' in person_c:
		pregs_control_person = pregs_control
		for i in range(len(person_c)):
			if person_c[i] in pregs_control_person:
				pregs_control_person.remove(person_c[i])
		for i in range(len(person_c)):
			if person_c[i] == 'nodata':
				person_c[i] = pregs_control_person[0]
				pregs_control_person.pop(0)

	big_person = {}
	big_person['rut'] = person + '-' + digito_verificador(person)
	big_person['score'] = person_s
	big_person['pregs'] = person_c
	big_person['resps'] = person_r

	ppl.append(big_person)

#pp = pprint.PrettyPrinter(indent=4)
#pp.pprint(ppl)

#bp()
# Creando el excel

wb = Workbook()
align = Alignment(horizontal='center',vertical='center')
dest_filename = name + '.xlsx'
ws1 = wb.active
ws1.title = "Datos"
#print(ppl)
cats = ppl[0]['pregs']
ws1.column_dimensions['A'].width = 11
header_index = [None] * len(cats)
for i in range(len(cats)):
	ws1[colnum_string(i+2)+'1'] = cats[i]
	ws1[colnum_string(i+2)+'1'].alignment = align
	ws1.column_dimensions[colnum_string(i+2)].width = 18
	header_index[i] = cats[i]

for i in range(len(ppl)):
	ws1['A'+str(i+2)] = ppl[i]['rut']
	#print(ppl[i]['rut'])
	for j in range(len(ppl[i]['pregs'])):
		hindex = header_index.index(ppl[i]['pregs'][j])
		#print(hindex)
		value = ppl[i]['score'][j]
		ws1[colnum_string(hindex+2)+str(i+2)] = value

ws2 = wb.create_sheet("Respuestas")
ws2.title = 'Respuestas'

#cats = ppl[0]['pregs']
ws1.column_dimensions['A'].width = 11
header_index = [None] * len(cats)
for i in range(len(cats)):
	ws2[colnum_string(i+2)+'1'] = cats[i]
	ws2[colnum_string(i+2)+'1'].alignment = align
	ws2.column_dimensions[colnum_string(i+2)].width = 18
	header_index[i] = cats[i]

for i in range(len(ppl)):
	ws2['A'+str(i+2)] = ppl[i]['rut']
	for j in range(len(ppl[i]['pregs'])):
		hindex = header_index.index(ppl[i]['pregs'][j])
		value = ppl[i]['resps'][j]
		ws2[colnum_string(hindex+2)+str(i+2)] = value

wb.save(filename = dest_filename)
#print(dest_filename+' terminado.')